pcl::features::ISMModel Struct Reference

The assignment of this structure is to store the statistical/learned weights and other information of the trained Implict Shape Model algorithm. More...

`#include <pcl/recognition/implicit_shape_model.h>`

## Public Types

using | Ptr = shared_ptr< ISMModel >
using | ConstPtr = shared_ptr< const ISMModel >

## Public Member Functions

| ISMModel ()
| Simple constructor that initializes the structure. More...
| ISMModel (ISMModel const &copy)
| Copy constructor for deep copy. More...
virtual | ~ISMModel ()
| Destructor that frees memory. More...
bool | saveModelToFile (std::string &file_name)
| This method simply saves the trained model for later usage. More...
bool | loadModelFromfile (std::string &file_name)
| This method loads the trained model from file. More...
void | reset ()
| this method resets all variables and frees memory. More...
ISMModel & | operator= (const ISMModel &other)
| Operator overloading for deep copy. More...

## Public Attributes

std::vector< std::vector< float > > | statistical_weights_
| Stores statistical weights. More...
std::vector< float > | learned_weights_
| Stores learned weights. More...
std::vector< unsigned int > | classes_
| Stores the class label for every direction. More...
std::vector< float > | sigmas_
| Stores the sigma value for each class. More...
Eigen::MatrixXf | directions_to_center_
| Stores the directions to objects center for each visual word. More...
Eigen::MatrixXf | clusters_centers_
| Stores the centers of the clusters that were obtained during the visual words clusterization. More...
std::vector< std::vector< unsigned int > > | clusters_
| This is an array of clusters. More...
unsigned int | number_of_classes_
| Stores the number of classes. More...
unsigned int | number_of_visual_words_
| Stores the number of visual words. More...
unsigned int | number_of_clusters_
| Stores the number of clusters. More...
unsigned int | descriptors_dimension_
| Stores descriptors dimension. More...

## Detailed Description

The assignment of this structure is to store the statistical/learned weights and other information of the trained Implict Shape Model algorithm.

Definition at line 156 of file implicit_shape_model.h.

## Member Typedef Documentation

## ConstPtr

using pcl::features::ISMModel::ConstPtr = shared_ptr<const ISMModel>

Definition at line 159 of file implicit_shape_model.h.

## Ptr

using pcl::features::ISMModel::Ptr = shared_ptr<ISMModel>

Definition at line 158 of file implicit_shape_model.h.

## Constructor & Destructor Documentation

## ISMModel() [1/2]

pcl::features::ISMModel::ISMModel | ( |  | ) |

Simple constructor that initializes the structure.

Definition at line 300 of file implicit_shape_model.hpp.

## ISMModel() [2/2]

pcl::features::ISMModel::ISMModel | ( | ISMModel const & | copy | ) |

Copy constructor for deep copy.

Definition at line 314 of file implicit_shape_model.hpp.

References classes_, clusters_centers_, descriptors_dimension_, directions_to_center_, learned_weights_, number_of_classes_, number_of_clusters_, number_of_visual_words_, sigmas_, and statistical_weights_.

## ~ISMModel()

pcl::features::ISMModel::~ISMModel | ( |  | ) |

virtual

Destructor that frees memory.

Definition at line 354 of file implicit_shape_model.hpp.

## Member Function Documentation

## loadModelFromfile()

bool pcl::features::ISMModel::loadModelFromfile | ( | std::string & | file_name | ) |

This method loads the trained model from file.

Parameters

  [in] | file_name | path to file which stores trained model

Definition at line 416 of file implicit_shape_model.hpp.

## operator=()

pcl::features::ISMModel & pcl::features::ISMModel::operator= | ( | const ISMModel & | other | ) |

Operator overloading for deep copy.

Definition at line 504 of file implicit_shape_model.hpp.

References classes_, clusters_centers_, descriptors_dimension_, directions_to_center_, learned_weights_, number_of_classes_, number_of_clusters_, number_of_visual_words_, sigmas_, and statistical_weights_.

## reset()

void pcl::features::ISMModel::reset | ( |  | ) |

this method resets all variables and frees memory.

Definition at line 487 of file implicit_shape_model.hpp.

## saveModelToFile()

bool pcl::features::ISMModel::saveModelToFile | ( | std::string & | file_name | ) |

This method simply saves the trained model for later usage.

Parameters

  [in] | file_name | path to file for saving model

Definition at line 361 of file implicit_shape_model.hpp.

## Member Data Documentation

## classes_

std::vector<unsigned int> pcl::features::ISMModel::classes_

Stores the class label for every direction.

Definition at line 197 of file implicit_shape_model.h.

Referenced by ISMModel(), and operator=().

## clusters_

std::vector<std::vector<unsigned int> > pcl::features::ISMModel::clusters_

This is an array of clusters.

Each cluster stores the indices of the visual words that it contains.

Definition at line 209 of file implicit_shape_model.h.

## clusters_centers_

Eigen::MatrixXf pcl::features::ISMModel::clusters_centers_

Stores the centers of the clusters that were obtained during the visual words clusterization.

Definition at line 206 of file implicit_shape_model.h.

Referenced by ISMModel(), and operator=().

## descriptors_dimension_

unsigned int pcl::features::ISMModel::descriptors_dimension_

Stores descriptors dimension.

Definition at line 221 of file implicit_shape_model.h.

Referenced by ISMModel(), and operator=().

## directions_to_center_

Eigen::MatrixXf pcl::features::ISMModel::directions_to_center_

Stores the directions to objects center for each visual word.

Definition at line 203 of file implicit_shape_model.h.

Referenced by ISMModel(), and operator=().

## learned_weights_

std::vector<float> pcl::features::ISMModel::learned_weights_

Stores learned weights.

Definition at line 194 of file implicit_shape_model.h.

Referenced by ISMModel(), and operator=().

## number_of_classes_

unsigned int pcl::features::ISMModel::number_of_classes_

Stores the number of classes.

Definition at line 212 of file implicit_shape_model.h.

Referenced by ISMModel(), and operator=().

## number_of_clusters_

unsigned int pcl::features::ISMModel::number_of_clusters_

Stores the number of clusters.

Definition at line 218 of file implicit_shape_model.h.

Referenced by ISMModel(), and operator=().

## number_of_visual_words_

unsigned int pcl::features::ISMModel::number_of_visual_words_

Stores the number of visual words.

Definition at line 215 of file implicit_shape_model.h.

Referenced by ISMModel(), and operator=().

## sigmas_

std::vector<float> pcl::features::ISMModel::sigmas_

Stores the sigma value for each class.

This values were used to compute the learned weights.

Definition at line 200 of file implicit_shape_model.h.

Referenced by ISMModel(), and operator=().

## statistical_weights_

std::vector<std::vector<float> > pcl::features::ISMModel::statistical_weights_

Stores statistical weights.

Definition at line 191 of file implicit_shape_model.h.

Referenced by ISMModel(), and operator=().

The documentation for this struct was generated from the following files:

- pcl/recognition/implicit_shape_model.h
- pcl/recognition/impl/implicit_shape_model.hpp